(ns compo1.views
(:use [hiccup core page]
        [incanter core stats charts]
        [compojure response])
(:import (java.io ByteArrayOutputStream
                    ByteArrayInputStream)))
(defn index-page []
(html5
    [:head
      [:title "Hello Ru"]
      (include-css "/css/style.css")]
    [:body
     [:h1 "Hello To"]]))
(defn gen-samp-hist-png []
(let [size 1000
          m 1
          s 5
          samp (sample-normal size
                    :mean m
                    :sd s)
          chart (histogram
                 samp
                 :title "Normal Sample"
                 :x-label (str "sample-size = " size
                               ", mean = " m
                               ", sd = " s))
          out-stream (ByteArrayOutputStream.)
          in-stream (do
                      (save chart out-stream)
                      (ByteArrayInputStream.
                       (.toByteArray out-stream)))]
      {:status 200
       :headers {"Content-Type" "image/png"}
       :body in-stream}))
