(ns inter.calc
(:require clojure.set)
(:use protege.core
  incanter.core
  incanter.charts
  incanter.io)
(:import 
  ru.oogis.dro.DroolsTab))
(def ^:dynamic *hum-ds* nil)
(defn read-hum-file [path]
(read-dataset path :header false :delim \space))
(defn sel-hum [date ds]
(sel ds :filter #(= (first %) date)))
(defn view-hum [dates ds]
(if (seq dates)
    (view (apply conj-rows (map #(sel-hum % ds) dates)) )))
(defn plot-hum [type date ds]
(let [se (sel ds :filter #(= (first %) date))
       x (sel se :cols 1)
       y (sel se :cols 2)
       xl "Hour"
       yl "Humidity"
       tit (str "SVD-forcast on " date)
       plot (condp = type 
	:scatter (scatter-plot x y :x-label xl :y-label yl :title tit)
	:xy (xy-plot x  y :x-label xl :y-label yl :title tit))]
   (view plot)))
(defn col-data [ds n]
(let [[c cns] (first ds)
       [r rows] (second ds)
       cn (nth cns n)]
   (map #(get % cn) rows)))
(defn dates-hum [ds]
(distinct (col-data ds 0)))
(defn set-hum-data-selector [inst path]
(let [ds (read-hum-file path)]
   (ssvs inst "string-collection" (dates-hum ds))
   (ssv inst "path" path)))
(defn hum-scatter-plot [hm inst]
(let [mp (into {} hm)
       sel (selection mp "string-collection")
       path (mp "path")
       ds (read-hum-file path)]
   (doall (map #(plot-hum :scatter % ds) sel))))
(defn hum-xy-plot [hm inst]
(let [mp (into {} hm)
       sel (selection mp "string-collection")
       path (mp "path")
       ds (read-hum-file path)]
   (doall (map #(plot-hum :xy % ds) sel))))
(defn hum-view [hm inst]
(let [mp (into {} hm)
       sel (selection mp "string-collection")
       path (mp "path")
       ds (read-hum-file path)]
   (view-hum sel ds)))
