/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2007 Ruslan P. Sorokin (sorokin@oogis.ru)
 * and Object-Oriented Geo-Information System Research Laboratory (http://www.oogis.ru)
 * All Rights Reserved.
 */
package ru.oogis.dro;

import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Slot;

public class KB {

	public static KnowledgeBase kb;

	// classes
	public static Cls c_Function;
	public static Cls c_Global;
	public static Cls c_Package;
	public static Cls c_ObjectPair;
	public static Cls c_Rule;
	public static Cls c_RuleBase;
	public static Cls c_Script;
	public static Cls c_ValuePair;
	public static Cls c_Variable;
	public static Cls c_WorkingMemory;
    // slots
	public static Slot s_activation_group;
	public static Slot s_agenda_group;
	public static Slot s_assert_classes;
	public static Slot s_assert_instances;
	public static Slot s_assert_strings;
	public static Slot s_auto_focus;
	public static Slot s_class;
	public static Slot s_collection;
	public static Slot s_context;
	public static Slot s_date_effective;
	public static Slot s_date_expires;
	public static Slot s_dialect;
	public static Slot s_display_fields;
	public static Slot s_dsl;
	public static Slot s_duration;
	public static Slot s_expander;
	public static Slot s_for_creation;
	public static Slot s_functions;
	public static Slot s_globals;
	public static Slot s_imports;
	public static Slot s_name;
	public static Slot s_no_loop;
	public static Slot s_object;
	public static Slot s_onto_topclasses;
	public static Slot s_onto_package;
	public static Slot s_onto_classpath;
	public static Slot s_onto_compiler;
	public static Slot s_packages;
	public static Slot s_pairs;
	public static Slot s_params;
	public static Slot s_path;
	public static Slot s_return_type;
	public static Slot s_rules;
	public static Slot s_salience;
	public static Slot s_scripts;
	public static Slot s_sort;
	public static Slot s_source;
	public static Slot s_string_collection;
	public static Slot s_suffix_wslot_tslot;
	public static Slot s_title;
	public static Slot s_then;
	public static Slot s_value;
	public static Slot s_variable;
	public static Slot s_when;
	public static Slot s_working_memory;

	public static void setKb(KnowledgeBase kb) {
		KB.kb = kb;
		// classes
		c_Function = kb.getCls("Function");
		c_Global = kb.getCls("Global");
		c_Package = kb.getCls("Package");
		c_ObjectPair = kb.getCls("ObjectPair");
		c_Rule = kb.getCls("Rule");
		c_RuleBase = kb.getCls("RuleBase");
		c_Script = kb.getCls("Script");
		c_ValuePair = kb.getCls("ValuePair");
		c_Variable = kb.getCls("Variable");
		c_WorkingMemory = kb.getCls("WorkingMemory");
	    // slots
		s_activation_group = kb.getSlot("activation-group");
		s_agenda_group = kb.getSlot("agenda-group");
		s_assert_classes = kb.getSlot("assert-classes");
		s_assert_instances = kb.getSlot("assert-instances");
		s_assert_strings = kb.getSlot("assert-strings");
		s_auto_focus = kb.getSlot("auto-focus");
		s_class = kb.getSlot("class");
		s_collection = kb.getSlot("collection");
		s_context = kb.getSlot("context");
		s_date_effective = kb.getSlot("date-effective");
		s_date_expires = kb.getSlot("date-expires");
		s_dialect = kb.getSlot("dialect");
		s_display_fields = kb.getSlot("display-fields");
		s_dsl = kb.getSlot("dsl");
		s_duration = kb.getSlot("duration");
		s_expander = kb.getSlot("expander");
		s_for_creation = kb.getSlot("for-creation");
		s_functions = kb.getSlot("functions");
		s_globals = kb.getSlot("globals");
		s_imports = kb.getSlot("imports");
		s_name = kb.getSlot(":NAME");
		s_no_loop = kb.getSlot("no-loop");
		s_object = kb.getSlot("object");
		s_onto_topclasses = kb.getSlot("onto-topclasses");
		s_onto_package = kb.getSlot("onto-package");
		s_onto_classpath = kb.getSlot("onto-classpath");
		s_onto_compiler = kb.getSlot("onto-compiler");
		s_packages = kb.getSlot("packages");
		s_pairs = kb.getSlot("pairs");
		s_params = kb.getSlot("params");
		s_path = kb.getSlot("path");
		s_return_type = kb.getSlot("return-type");
		s_rules = kb.getSlot("rules");
		s_salience = kb.getSlot("salience");
		s_scripts = kb.getSlot("scripts");
		s_sort = kb.getSlot("sort");
		s_source = kb.getSlot("source");
		s_string_collection = kb.getSlot("string-collection");
		s_suffix_wslot_tslot = kb.getSlot("suffix-wslot-tslot");
		s_title = kb.getSlot("title");
		s_then = kb.getSlot("then");
		s_value = kb.getSlot("value");
		s_variable = kb.getSlot("variable");
		s_when = kb.getSlot("when");
                s_working_memory = kb.getSlot("working-memory");
	}
}
