/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2007 Ruslan P. Sorokin (sorokin@oogis.ru)
 * and Object-Oriented Geo-Information System Research Laboratory (http://www.oogis.ru)
 * All Rights Reserved.
 */
package ru.oogis.util;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

public class DroClock {
	
	private int second;

	private final PropertyChangeSupport changes = new PropertyChangeSupport( this );

	public void addPropertyChangeListener(final PropertyChangeListener l) {
	    this.changes.addPropertyChangeListener( l );
	}

	public void removePropertyChangeListener(final PropertyChangeListener l) {
	    this.changes.removePropertyChangeListener( l );
	}

	public void setSecond(final int newSecond) {
	    int oldSecond = second;
	    second = newSecond;
	    changes.firePropertyChange( "second", oldSecond, newSecond );
	}

	public int getSecond() {
		return second;
	}
	
	public String toString(){
		return "ru.oogis.util.DroClock < second: "+second+" >";
	}
}
