/*
 * Created on 31.05.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ru.igis.omtab;

import java.awt.BorderLayout;
import java.awt.Component;
import java.util.Collection;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import com.bbn.openmap.gui.OMToolComponent;

import edu.stanford.smi.protege.event.FrameAdapter;
import edu.stanford.smi.protege.event.FrameEvent;
import edu.stanford.smi.protege.event.FrameListener;
import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.model.Frame;
import edu.stanford.smi.protege.model.Instance;
import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.model.Slot;
import edu.stanford.smi.protege.ui.ProjectManager;
import edu.stanford.smi.protege.widget.ClsWidget;

/**
 * @author Ru
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MultiUser extends OMToolComponent {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 1L;
	
	private static String LEADER = "Leader: ";
	private static String DRIVEN = "Driven: ";
	private static String LEADER_CURTIME = "L_CT";
	private static String LEADER_MAPOBS  = "L_MO";
	private static String DRIVEN_CURTIME = "D_CT";
	private static String DRIVEN_MAPOBS  = "D_MO";

	private KnowledgeBase kb;
	private Project project;
	private Instance multiuser;
	private Slot slot_leader;
	private Slot slot_synchro;
	private Slot slot_timescale;
	private Slot slot_running;
	private Slot slot_accuracy;
	private Slot slot_curtime;
	private Slot slot_messages;
	private Slot slot_last_connect;
	private RuNA runa;
	private boolean multiUserMode = false;
	private boolean leader = false;
	private String localUser;
	@SuppressWarnings({ "rawtypes" })
	private Collection currentUsers;
	private boolean init = false;
	private long synchro_interval = 120;
	private long synchro_accuracy = 4;
	private MultiSynchroAction multiSA;
	private String who;
	private FrameListener curtimeListener;
	private Object leaderName;
	private JFrame frame;
	/**
	 * 
	 */
	public MultiUser() {
		super();
        initComponents();
    }
	
    private void initComponents(){
    	JButton jButtonClient = new JButton("M");
	    jButtonClient.setToolTipText("Multiuser Control");
	    jButtonClient.setMargin(new java.awt.Insets(2, 2, 2, 2));
	    jButtonClient.addActionListener(new java.awt.event.ActionListener() {
	        public void actionPerformed(java.awt.event.ActionEvent evt) {
	        	if(getKb() != null){
	        		if(!init){
		        		if(multiUserMode){
		        			if(leader){
								who = LEADER;
								toKBLastConnect(LEADER_CURTIME);
		        			} else {
								who = DRIVEN;
								toKBLastConnect(DRIVEN_CURTIME);
							}
							curtimeListener = new FrameAdapter(){
								public void ownSlotValueChanged(FrameEvent event){
									slotValueChangeCurtime(event.getSlot());
								} 
							};
							((Frame)multiuser).addFrameListener(curtimeListener);
		        		}
	        		} else
						showMultiUser();
	        	}
	        }
	    });
	    add(jButtonClient);
    }
    
    public void showMultiUser(){
		if(frame == null){
			ClsWidget widget = project.createRuntimeClsWidget(multiuser);
			frame = new JFrame(who+localUser);
			frame.getContentPane().setLayout(new BorderLayout());
			frame.getContentPane().add((Component) widget,BorderLayout.CENTER);
			JButton ts = new JButton("TS");
			ts.setToolTipText("Synchronize Time");
		    ts.addActionListener(new java.awt.event.ActionListener() {
		        public void actionPerformed(java.awt.event.ActionEvent evt) {
					toKBCurtime(runa.getClock().getClock()/1000 + 1);
				}
		    });
			JButton mos = new JButton("MOS");
			mos.setToolTipText("Synchronize MapOb positions");
		    mos.addActionListener(new java.awt.event.ActionListener() {
		        public void actionPerformed(java.awt.event.ActionEvent evt) {
					try {
						runa.mapBackMapObs(null);
					} catch (Exception e) {
						System.out.println(who+"runa.mapBackMapObs(null) exception:\n");
						e.printStackTrace();
					}
		        }
		    });
			JPanel bp = new JPanel();
			bp.add(ts);
			bp.add(mos);
			frame.getContentPane().add(bp,BorderLayout.SOUTH);
			if(!leader){
				ts.setEnabled(false);
				mos.setEnabled(false);
			}
			frame.pack();
		}
		frame.setVisible(true);
		frame.toFront();
    }
    
    private void initLeader(){
		System.out.println(who+"initializing ...");
		setAccuracy((String) multiuser.getOwnSlotValue(slot_accuracy));
		setMultiSynchroAction((String) multiuser.getOwnSlotValue(slot_synchro));
		if(currentUsers.isEmpty()){
			// Leader start first
			toKBRunning(runa.isTimerRunning());
			toKBTimeScale(runa.getTimeScale());
			toKBCurtime(runa.getClock().getClock()/1000 + 1);
		} else {
			// Leader start not first
			fromKBTimeScale((String) multiuser.getOwnSlotValue(slot_timescale));
			fromKBRunning((String) multiuser.getOwnSlotValue(slot_running));
		}
		((Frame)multiuser).addFrameListener(new FrameAdapter(){
			public void ownSlotValueChanged(FrameEvent event){
				try {
					slotValueChangeLeader(event.getSlot());
				} catch (Exception e) {
					System.out.println(who+"ownSlotValueChanged exception:\n");
					e.printStackTrace();
				}
			} 
		});
    }
    
    private void initDriven(){
		System.out.println(who+"initializing ...");
		runa.disableDrivenGUI();
		setAccuracy((String) multiuser.getOwnSlotValue(slot_accuracy));
		fromKBCurtime((String) multiuser.getOwnSlotValue(slot_curtime));
		fromKBTimeScale((String) multiuser.getOwnSlotValue(slot_timescale));
		fromKBRunning((String) multiuser.getOwnSlotValue(slot_running));
		((Frame)multiuser).addFrameListener(new FrameAdapter(){
			public void ownSlotValueChanged(FrameEvent event){
				try {
					slotValueChangeDriven(event.getSlot());
				} catch (Exception e) {
					System.out.println(who+"ownSlotValueChanged exception:\n");
					e.printStackTrace();
				}
			} 
		});
    }
    
    private void slotValueChangeCurtime(Slot slot){
    	if(slot.equals(slot_curtime)){
			fromKBCurtime((String) multiuser.getOwnSlotValue(slot_curtime));
			((Frame)multiuser).removeFrameListener(curtimeListener);
			if(leader){
				initLeader();
				toKBLastConnect(LEADER_MAPOBS);
			} else {
				initDriven();
				toKBLastConnect(DRIVEN_MAPOBS);
			}
    		init = true;
			showMultiUser();
    	}
	}

	private void slotValueChangeLeader(Slot slot) throws Exception{
    	if(slot.equals(slot_accuracy))
    		setAccuracy((String) multiuser.getOwnSlotValue(slot_accuracy));
    	else if(slot.equals(slot_synchro))
    		setMultiSynchroAction((String) multiuser.getOwnSlotValue(slot_synchro));
    	else if(slot.equals(slot_messages))
    		showMultiUser();
    	else if(slot.equals(slot_last_connect))
    		lastConnectChanged((String) multiuser.getOwnSlotValue(slot_last_connect));
    }
    
    private void slotValueChangeDriven(Slot slot) throws Exception{
    	if(slot.equals(slot_running))
    		fromKBRunning((String) multiuser.getOwnSlotValue(slot_running));
    	else if(slot.equals(slot_timescale))
			fromKBTimeScale((String) multiuser.getOwnSlotValue(slot_timescale));
    	else if(slot.equals(slot_curtime))
			fromKBCurtime((String) multiuser.getOwnSlotValue(slot_curtime));
    	else if(slot.equals(slot_messages))
    		showMultiUser();
    	else if(slot.equals(slot_last_connect))
    		lastConnectChanged((String) multiuser.getOwnSlotValue(slot_last_connect));
    }
    
	private KnowledgeBase getKb(){
    	if(kb == null){
    		project = ProjectManager.getProjectManager().getCurrentProject();
    		kb = project.getKnowledgeBase();
    		Cls muc = kb.getCls(Ontology.C_MULTIUSER);
    		if(muc == null){
    			System.out.println(who+"Class "+Ontology.C_MULTIUSER+" not found!");
    			return null;
    		}
    		Collection<Instance> mus = muc.getInstances();
      		if(mus.isEmpty()){
    			System.out.println(who+"Instances of "+Ontology.C_MULTIUSER+" not found!");
    			return null;
    		}
      		multiuser = mus.iterator().next();
      		slot_accuracy = kb.getSlot(Ontology.S_ACCURACY);
      		slot_curtime = kb.getSlot(Ontology.S_CURTIME);
      		slot_leader = kb.getSlot(Ontology.S_LEADER);
      		slot_messages = kb.getSlot(Ontology.S_MESSAGES);
      		slot_running = kb.getSlot(Ontology.S_RUNNING);
      		slot_synchro = kb.getSlot(Ontology.S_SYNCHRO);
      		slot_timescale = kb.getSlot(Ontology.S_TIMESCALE);
      		slot_last_connect = kb.getSlot(Ontology.S_LAST_CONNECT);
      		// check mode
			multiUserMode =project.isMultiUserClient();
      		if(multiUserMode){
      			localUser = project.getLocalUser();
				currentUsers = project.getCurrentUsers();
				currentUsers.remove(localUser);
				if(currentUsers.contains(localUser)){
					JOptionPane.showMessageDialog(null,"User "+localUser+" is already on-line!");
					System.exit(0);
				}
      			leaderName = multiuser.getOwnSlotValue(slot_leader);
      			leader = leaderName.equals(localUser);
				if(leader && currentUsers.isEmpty()){
					who = LEADER;
					initLeader();
					init = true;
				}
			}
    	}
   		return kb;
    }

    public void findAndInit(Object obj) {
        if (obj instanceof RuNA) {
        	runa = (RuNA) obj;
        	runa.setMultiUser(this);
        }
    }

    public void findAndUndo(Object obj) {
        if (obj instanceof RuNA) {
        	runa.setMultiUser(null);
        	runa = null;
        }
    }
	/**
	 * @return Returns the multiUserMode.
	 */
	public boolean isMultiUserMode() {
		return multiUserMode;
	}
	/**
	 * @return Returns the leader.
	 */
	public boolean isLeader() {
		return leader;
	}
	
	public void toKBTimeScale(String timeScale){
		multiuser.setOwnSlotValue(slot_timescale,timeScale);
	}

	public void fromKBTimeScale(String timeScale){
		runa.setTimeScale((String) multiuser.getOwnSlotValue(slot_timescale));
	}

	public void fromKBRunning(String running){
		if(running.equals("true"))
			runa.setTimerRunning(true);
		else
			runa.setTimerRunning(false);
	}
	
	public void toKBRunning(boolean running){
		if(running)
			multiuser.setOwnSlotValue(slot_running,"true");
		else
			multiuser.setOwnSlotValue(slot_running,"false");
	}

	public void toKBLastConnect(String who){
		multiuser.setOwnSlotValue(slot_last_connect,who);
	}
	
	private void lastConnectChanged(String lastConnect) throws Exception{
		if(leader && lastConnect.equals(DRIVEN_CURTIME)){
			toKBCurtime(runa.getClock().getClock()/1000 + 1);
			toKBLastConnect("");	
		} else if(!leader && lastConnect.equals(LEADER_CURTIME)){
			toKBCurtime(runa.getClock().getClock()/1000 + 1);
			toKBLastConnect("");	
		} else if(leader && lastConnect.equals(DRIVEN_MAPOBS)){
			runa.mapBackMapObs(null);
			toKBLastConnect("");	
		} else if(!leader && lastConnect.equals(LEADER_MAPOBS)){
			runa.mapBackMapObs(null);
			toKBLastConnect("");	
		}
	}

	public void fromKBCurtime(String seconds){
		try {
			Clock clock = runa.getClock();
			long corr_sec = Integer.parseInt(seconds);
			long uncr_sec = clock.getClock()/1000;
			if(Math.abs(corr_sec - uncr_sec) > synchro_accuracy)
				clock.setClock(corr_sec * 1000);
		} catch (NumberFormatException e) {
			System.out.println(who+"wrong curtime sec format "+seconds);
		}
	}
	
	public void toKBCurtime(long milliseconds){
		multiuser.setOwnSlotValue(slot_curtime, milliseconds+"");
	}
	
	private void setAccuracy(String synchro){
		try {
			synchro_accuracy = Integer.parseInt(synchro);
		} catch (NumberFormatException e) {
			System.out.println(who+"wrong synchro accuracy "+synchro+", set default "+synchro_accuracy);
		}
		System.out.println(who+"synchro accuracy "+synchro_accuracy);
	}

	private void setMultiSynchroAction(String synchro){
		try {
			synchro_interval = Integer.parseInt(synchro);
			if(multiSA == null){
				multiSA = new MultiSynchroAction();
				runa.addSecondAction(multiSA);
			}
		} catch (NumberFormatException e) {
			System.out.println(who+"wrong synchro interval "+synchro+", set default "+synchro_interval);
		}
		System.out.println(who+"synchro interval "+synchro_interval);
	}
	
	private class MultiSynchroAction implements RepeatAction {

		float elapsed = 0;
		Clock clock = runa.getClock();
		/* (non-Javadoc)
		 * @see ru.igis.omtab.RepeatAction#repeat(long)
		 */
		public void repeat(long time) {
			elapsed += time / clock.getTimeScale();
			// System.out.println("MU repeat "+time+" "+elapsed);
			if(elapsed > synchro_interval){
				toKBCurtime(runa.getClock().getClock()/1000 + 1);
				elapsed = 0;
			}
		}

		/* (non-Javadoc)
		 * @see ru.igis.omtab.RepeatAction#getName()
		 */
		public String getName() {
			return MultiSynchroAction.class.getName();
		}

		/* (non-Javadoc)
		 * @see ru.igis.omtab.RepeatAction#setName(java.lang.String)
		 */
		public void setName(String name) {
		}
	}

	public Object getLeaderName() {
		return leaderName;
	}

	public String getLocalUser() {
		return localUser;
	}
}
