/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2004 Sorokin R.P. (sorokinru@iias.spb.su)
 * and Object-oriented Geoinformatics Systems Laboratory (http://niggis.iias.spb.su)
 * All Rights Reserved.
 */

package ru.igis.omtab;

/**
 * Interface for implementation periodically repeating actions
 * @author Ru
 */
public interface RepeatAction {
    
    /**
     * Method incapsulating repeating action functionallity
     * @param time - number of time units elapsed from previous call
     */    
    public void repeat(long time);
    
    /**
     * Every RepeatAction must return a string name to search it in
     * Second, Hour or Day Action lists
     * @return Some string 
     */
    public String getName();
    
    /**
     * You can set name for this RepeatAction with a help of this method
     * @param name new name for RA
     */
    public void setName(String name);
    
}
