/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2004 Sorokin R.P. (sorokinru@iias.spb.su)
 * and Object-oriented Geoinformatics Systems Laboratory (http://niggis.iias.spb.su)
 * All Rights Reserved.
 */

package ru.igis.omtab;

import javax.swing.*;
/**
 * Distinct GUI for control of RuNA Object
 * @author Ru
 */
public class RunaPanel extends javax.swing.JPanel {

    /**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 1L;
	
	/**
     * Creates new form RunaPanel
     * @param r - RuNA Object
     */
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public RunaPanel(RuNA r) {
        initComponents();
        runa = r;
        java.util.Hashtable dict = new java.util.Hashtable();
        dict.put(new Integer(10), new JLabel("1"));
        dict.put(new Integer(20), new JLabel("2"));
        dict.put(new Integer(30), new JLabel("3"));
        dict.put(new Integer(40), new JLabel("4"));
        dict.put(new Integer(50), new JLabel("5"));
        jSliderTimer.setLabelTable(dict);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanelButtons = new javax.swing.JPanel();
        jButtonAddObsToMap = new javax.swing.JButton();
        jButtonRemoveObsFromMap = new javax.swing.JButton();
        jButtonMapBack = new javax.swing.JButton();
        jButtonControlObject = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jPanelTimer = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jSliderTimer = new javax.swing.JSlider();
        jLabel3 = new javax.swing.JLabel();
        jLabelTimeScale = new javax.swing.JLabel();
        jButtonTSPlus = new javax.swing.JButton();
        jButtonTSMinus = new javax.swing.JButton();
        jPanelClock = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldModelClock = new javax.swing.JTextField();
        jCheckBoxRunTimer = new javax.swing.JCheckBox();
        jButtonStartScenario = new javax.swing.JButton();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        jPanelButtons.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jButtonAddObsToMap.setText("Add Objects           ");
        jButtonAddObsToMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddObsToMapActionPerformed(evt);
            }
        });

        jPanelButtons.add(jButtonAddObsToMap);

        jButtonRemoveObsFromMap.setText("Remove Objects");
        jButtonRemoveObsFromMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveObsFromMapActionPerformed(evt);
            }
        });

        jPanelButtons.add(jButtonRemoveObsFromMap);

        jButtonMapBack.setText("Map Back Objects");
        jButtonMapBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMapBackActionPerformed(evt);
            }
        });

        jPanelButtons.add(jButtonMapBack);

        jButtonControlObject.setText("Control Object");
        jButtonControlObject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonControlObjectActionPerformed(evt);
            }
        });

        jPanelButtons.add(jButtonControlObject);

        jPanelButtons.add(jSeparator1);

        add(jPanelButtons);

        jLabel2.setText("Timer interval (sec)");
        jPanelTimer.add(jLabel2);

        jSliderTimer.setMajorTickSpacing(5);
        jSliderTimer.setMaximum(50);
        jSliderTimer.setPaintLabels(true);
        jSliderTimer.setPaintTicks(true);
        jSliderTimer.setValue(10);
        jSliderTimer.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderTimerStateChanged(evt);
            }
        });

        jPanelTimer.add(jSliderTimer);

        jLabel3.setText("Time Scale");
        jPanelTimer.add(jLabel3);

        jLabelTimeScale.setText("1:1");
        jPanelTimer.add(jLabelTimeScale);

        jButtonTSPlus.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ru/igis/omtab/resources/n.gif")));
        jButtonTSPlus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTSPlusActionPerformed(evt);
            }
        });

        jPanelTimer.add(jButtonTSPlus);

        jButtonTSMinus.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ru/igis/omtab/resources/s.gif")));
        jButtonTSMinus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTSMinusActionPerformed(evt);
            }
        });

        jPanelTimer.add(jButtonTSMinus);

        add(jPanelTimer);

        jPanelClock.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel1.setText("Model Clock");
        jPanelClock.add(jLabel1);

        jTextFieldModelClock.setColumns(20);
        jPanelClock.add(jTextFieldModelClock);

        jCheckBoxRunTimer.setText("Run Timer");
        jCheckBoxRunTimer.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jCheckBoxRunTimeStateChanged(evt);
            }
        });

        jPanelClock.add(jCheckBoxRunTimer);

        jButtonStartScenario.setText("Start Scenario");
        jButtonStartScenario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStartScenarioActionPerformed(evt);
            }
        });

        jPanelClock.add(jButtonStartScenario);

        add(jPanelClock);

    }//GEN-END:initComponents

    private void jButtonStartScenarioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartScenarioActionPerformed
        try{
            Util.execScenario(runa.getScenario());
        } catch (Exception exc) {
            String mess = exc.getMessage();
            if(mess!=null)
                JOptionPane.showMessageDialog(this,exc.toString());
            else
                exc.printStackTrace();
        }
    }//GEN-LAST:event_jButtonStartScenarioActionPerformed

    private void jButtonMapBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMapBackActionPerformed
        runa.cmdMapBackObjects();
    }//GEN-LAST:event_jButtonMapBackActionPerformed

    private void jButtonControlObjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonControlObjectActionPerformed
        runa.cmdControlObject();
    }//GEN-LAST:event_jButtonControlObjectActionPerformed

    private void jButtonTSPlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTSPlusActionPerformed
        if(den<2)
            num = num * 2;
        else
            den = den / 2;
        runa.setTimeScale(num+":"+den);
    }//GEN-LAST:event_jButtonTSPlusActionPerformed

    private void jButtonTSMinusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTSMinusActionPerformed
        if(num<2)
            den = den * 2;
        else
            num = num / 2;
        runa.setTimeScale(num+":"+den);
    }//GEN-LAST:event_jButtonTSMinusActionPerformed

    private void jSliderTimerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderTimerStateChanged
        if (jSliderTimer.getValueIsAdjusting()) {
            runa.setUpdateInterval((int)getSliderInterval());
        }
    }//GEN-LAST:event_jSliderTimerStateChanged

    private void jCheckBoxRunTimeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jCheckBoxRunTimeStateChanged
        runa.setUpdateInterval((int)getSliderInterval());
        runa.setTimerRunning(jCheckBoxRunTimer.isSelected(),false);
    }//GEN-LAST:event_jCheckBoxRunTimeStateChanged

    private void jButtonRemoveObsFromMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveObsFromMapActionPerformed
        runa.cmdRemObsFromMap();
    }//GEN-LAST:event_jButtonRemoveObsFromMapActionPerformed

    private void jButtonAddObsToMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddObsToMapActionPerformed
        runa.cmdAddObsToMap();
    }//GEN-LAST:event_jButtonAddObsToMapActionPerformed

    /**
     * Method to set Clock field
     * @param c - text for Clock field
     */
    public void setClock(String c){
        jTextFieldModelClock.setText(c);
    }

    protected void updateTimeScaleText(String text){
    	jLabelTimeScale.setText(text);
    }

    /**
     * Method to disable and enable time ticks slider
     * @param se - enable or disable slider
     */
    protected void setSliderEnabled(boolean se){
        jSliderTimer.setEnabled(se);
    }
    protected void setRunTimerSelected(boolean cbs){
        jCheckBoxRunTimer.setSelected(cbs);
    }
    /**
     * Method to get time interval between ticks in milliseconds
     * @return - milliseconds
     */
    public float getSliderInterval(){
        //Debug.output("RuNA Timer delay set to: " + interval/1000f + " seconds");
        return ((float)(jSliderTimer.getValue()) + .01f) * 100f;
    }

    protected void disableDrivenGUI(){
    	jButtonTSMinus.setEnabled(false);
    	jButtonTSPlus.setEnabled(false);
    	jCheckBoxRunTimer.setEnabled(false);
    	jButtonStartScenario.setEnabled(false);
    }

    /*
    public static void main(String[] args){
        JFrame f = new JFrame();
        RunaPanel rp = new RunaPanel(null);
        f.getContentPane().add(rp);
        f.pack();
        f.show();
    }
     */

    private int num = 1;      // time scale numerator
    private int den = 1;      // time scale denominator;

    private RuNA runa;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAddObsToMap;
    private javax.swing.JButton jButtonControlObject;
    private javax.swing.JButton jButtonMapBack;
    private javax.swing.JButton jButtonRemoveObsFromMap;
    private javax.swing.JButton jButtonStartScenario;
    private javax.swing.JButton jButtonTSMinus;
    private javax.swing.JButton jButtonTSPlus;
    private javax.swing.JCheckBox jCheckBoxRunTimer;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelTimeScale;
    private javax.swing.JPanel jPanelButtons;
    private javax.swing.JPanel jPanelClock;
    private javax.swing.JPanel jPanelTimer;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSlider jSliderTimer;
    private javax.swing.JTextField jTextFieldModelClock;
    // End of variables declaration//GEN-END:variables

}
