import edu.stanford.smi.protege.model.*
import edu.stanford.smi.protege.ui.*
import java.awt.BorderLayout
import javax.swing.*
//import scenlay.core

def sv( i, s, kb ) {
 i.getOwnSlotValue( kb.getSlot( s ) )
}

def svs( i, s, kb ) {
 i.getOwnSlotValues( kb.getSlot( s ) )
}

def ssv( i, s, v, kb ) {
 i.setOwnSlotValue( kb.getSlot( s ), v )
}

def ssvs( i, s, v, kb ) {
 i.setOwnSlotValues( kb.getSlot( s ), v )
}

def definePath( p, prj ) {
 if( p == null )
  p = prj.projectDirectoryFile.path
 filch( p )
}

def loadSecondProject( p, prj2 ) {
 if( p == null )
  return
 def err = new ArrayList()
 if( prj2 != null )
  prj2.dispose()
 prj2 = new Project( p, err )
 dro.printout( "\nloading "+p+" errors "+err.size )
 if( err.size > 0 ){
  err.each{ dro.printout( "error: "+it ) }
  return null
 }
 prj2
}

def findUnref() {
 def cls = DisplayUtilities.pickCls( null, kb, [ kb.getCls( ":THING" ) ] )
 dro.printout( "\nUnreferenced "+cls.name+"s:\n" )
 cls.instances.each{
  if( it.references.size() < 2 )
   dro.printout( prettyName( it, kb ) )
 }
}

def deleteUnref() {
 def cls = DisplayUtilities.pickCls( null, kb, [ kb.getCls( ":THING" ) ] )
 dro.printout( "\nDelete Unreferenced "+cls.name+"s:\n" )
 delUnrefClass( cls.name )
}

def prettyName( i, kb ) {
 def nam = sv( i, "title", kb )
 if( nam == null )
  nam = sv( i, "label", kb )
 if( nam == null )
  nam = i.name
 return nam
}

def delUnrefClass( nam ) {
  def cnt = 0
  kb.getCls( nam ).instances.each{
    if( it.references.size() < 2 )
    {
      kb.deleteInstance( it )
      cnt++
    }
  }
  dro.printout( cnt+" "+nam+"s deleted" )
}

def deleteScenarios() {
 def ii = DisplayUtilities.pickInstances( null, kb, [ kb.getCls( "Scenario" ) ] )
 dro.printout( "\nDeleting scenarios:\n" )
 ii.each{
  def tit = sv( it, "title", kb )
  deleteTasks( svs( it, "initial_tasks", kb ) )
  kb.deleteInstance( it )
  delUnrefClass( "ScenarioScheme" )
  delUnrefClass( "TaskScheme" )
  delUnrefClass( "Context" )
  delUnrefClass( "Pair" )
  delUnrefClass( "Variable" )
  dro.printout( "Scenario "+tit+" deleted" )
 }
}

def deleteTasks( tasks ) {
 tasks.each{
  def tit = sv( it, "title", kb )
  def nt = svs( it, "next_tasks", kb )
  def vt = svs( it, "variants", kb )
  deleteActions( svs( it, "initial_actions", kb ) )
  kb.deleteInstance( it )
  deleteTasks( nt )
  deleteTasks( vt )
  dro.printout( "  Task "+tit+" deleted" )
 }
}

def deleteActions( actions ) {
 actions.each{
  def tit = sv( it, "title", kb )
  def aa = svs( it, "next_actions", kb )
  kb.deleteInstance( it )
  deleteActions( aa )
  dro.printout( "    Action "+tit+" deleted" )
 }
}

def LSPF() {
 JOptionPane.showMessageDialog( null, "Load Second Project first!" )
 return null
}

def cc = null
def copyScenarios( kb2, pool ) {
 if( kb2 == null )
  return LSPF()
 cc = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( "Scenario" ) ] )
 dro.printout( "\nCopy scenarios:\n" )
 cc.each{
  dro.printout( sv( it, "title", kb2 ) )
  getInstanceCopy( it, kb, kb2, pool )
 }
 println "Have a look on scenarios:"
 cc.each { println "  "+sv( it, "title", kb2 )}
 println " and Layout Scenarios!"
}

def layoutScenarios( kb2 ) {
 if( cc == null)
   return
 def err = new ArrayList()
 prj.save(err)
 println "Project saved: "+err
 def a = new String[2]
 a[0] = prj.projectURI.path
 a[1] = "CopiedScenarioLayouts.txt"
 new File(a[1]).withWriter { out ->
  out.writeLine( "{" )
  cc.each{
   layoutMap( it, kb2, out )
  }
  out.writeLine( "}" )
 }
 println "Created file: "+a[1]
 core.main( a )
 println "Reopen project: "+a[0]
}

def layoutMap( ins, kb2, out ) {
 def ssl = kb2.getSlot( "scenario_scheme" )
 def cw =  kb2.project.createRuntimeClsWidget( ins )
 def frm = new JFrame()
 frm.getContentPane().add( cw )
 frm.pack()
 def sw = cw.getSlotWidget( ssl )
 def gd = sw.document
 def lst = ins.getOwnSlotValues( ssl )
 def map = []
 lst.each{
  def rec = gd.getNodeRectangle( it )
  out.writeLine( "\""+sv( it, "title", kb2 )+"\" "+[(rec.x as int), (rec.y as int), (rec.width as int), (rec.height as int)] )
 }
}

def copyInstances( kb1, kb2, pool ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( ":THING" ) ] )
 dro.printout( "\nCopy instances:\n" )
 def cnt = 1
 lst.each{
  def nsv = tlSlotVal( it, kb2 )
  getInstanceCopy( it, kb1, kb2, pool )
  if ( nsv != null )
    dro.printout( cnt+". "+nsv[0]+": "+nsv[1] )
  else
    dro.printout( cnt+". "+it )
  cnt++
 }
}

def tlSlotVal( i, kb2 ){
 def sn = "title"
 def nam = sv( i, sn, kb2 )
 if( nam == null ){
  sn = "label"
  nam = sv( i, sn, kb2 )
 }
 if( nam == null )
  return null
 else
  return [ sn, nam ]
}

def trace( i, kb ) {
  def tn = i.directType.name
  def tlsv = tlSlotVal( i, kb )
  if ( tlsv != null )
    return tn+": "+tlsv[1]
  else
    return tn+": "+i.name
}

def getInstanceCopy( i, kb1, kb2, pool ) {
 //println trace( i, kb2 )
 if( i == null )
  return null
 def stored = pool[ i ]
 if ( stored != null )
  return stored
 def tn = i.directType.name
 def typ = kb1.getCls( tn )
 if( typ == null ) {
  dro.printout( "Class of "+i+" not exists!" )
  return null;
 }
 def c = kb1.createInstance( null, typ )
 pool[ i ] = c
 def tlsv = tlSlotVal( i, kb2 )
 if( tlsv != null ) {
  def e = dro.findForSlotValue( tn, tlsv[0], tlsv[1] )
  if( e != null )
   tlsv[1] = getNewName( tlsv[1] )
  ssv( c, tlsv[0], tlsv[1], kb1 )
 }
 typ.templateSlots.each{
  def sn = it.name
  if( !sn.startsWith( ":" ) && ( tlsv == null || sn != tlsv[0]) ) {
   if( it.allowsMultipleValues )
    ssvs(
     c,
     sn,
     svs( i, sn, kb2 ).collect{ findOrCreateCopy( it, kb1, kb2, pool ) },
     kb1
    )
   else
    ssv( c, sn, findOrCreateCopy( sv( i, sn, kb2 ), kb1, kb2, pool ), kb1 )
  }
 }
 c
}

def findOrCreateCopy( v2, kb1, kb2, pool ) {
 if( v2 instanceof Cls ) {
  def cc = kb1.getCls( v2.name )
  if( cc == null )
   dro.printout( "Copy class "+v2+" before!" )
  return cc
 }
 if( v2 instanceof Instance ) {
   return getInstanceCopy( v2, kb1, kb2, pool )
 }
 return v2
}

def convertScenario( i, kb1, kb2 ) {
}

def filch( s ) {
 def c = new JFileChooser( s )
 def rv = c.showOpenDialog( null )
 if ( rv == javax.swing.JFileChooser.APPROVE_OPTION ) {
  return c.selectedFile.path
 }
 null
}

def getDir( path ) {
 def i = path.lastIndexOf( "/" )
 path.substring( 0, i )
}

def getNewName( pfx ) {
  def d = "_"+new Date()
  d = d.replaceAll( " ", "_" )
  return pfx+d
}

def swb = new groovy.swing.SwingBuilder()
def path
def prj2
def kb2
def pool = [:]

def frame = swb.frame( title: 'Scenario Processing' ) {
 boxLayout(axis:BoxLayout.Y_AXIS)
 panel( border: BorderFactory.createTitledBorder( "Functions" ) ) {
  gridLayout( columns:1, rows: 7 )
  button ( text: 'Load Second Project', actionPerformed: {
   path = definePath( path, prj )
   prj2 = loadSecondProject( path, prj2 )
   kb2 = prj2.knowledgeBase
  } )
  button ( text: 'Find Unreferenced', actionPerformed: { findUnref() } )
  button ( text: 'Delete Unreferenced', actionPerformed: { deleteUnref() } )
  button ( text: 'Delete Scenarios', actionPerformed: { deleteScenarios() } )
  button ( text: 'Copy Scenarios', actionPerformed: { copyScenarios( kb2, pool ) } )
  button ( text: 'Layout Scenarios', actionPerformed: { layoutScenarios( kb2 ) } )
  button ( text: 'Copy TL-Instances', actionPerformed: { copyInstances( kb, kb2, pool ) } )
 }
}
frame.pack()
frame.show()
