import edu.stanford.smi.protege.model.*
import edu.stanford.smi.protege.ui.*
import java.awt.BorderLayout
import javax.swing.*

def sv( i, s, kb ) {
 i.getOwnSlotValue( kb.getSlot( s ) )
}

def svs( i, s, kb ) {
 i.getOwnSlotValues( kb.getSlot( s ) )
}

def ssv( i, s, v, kb ) {
 i.setOwnSlotValue( kb.getSlot( s ), v )
}

def ssvs( i, s, v, kb ) {
 i.setOwnSlotValues( kb.getSlot( s ), v )
}

def definePath( p, prj ) {
 if( p == null )
  p = prj.projectDirectoryFile.path
 filch( p )
}

def loadSecondProject( p, prj2 ) {
 if( p == null )
  return
 def err = new ArrayList()
 if( prj2 != null )
  prj2.dispose()
 prj2 = new Project( p, err )
 dro.printout( "\nloading "+p+" errors "+err.size )
 if( err.size > 0 ){
  err.each{ dro.printout( "error: "+it ) }
  return null
 }
 prj2
}

def findUnref() {
 def cls = DisplayUtilities.pickCls( null, kb, [ kb.getCls( ":THING" ) ] )
 dro.printout( "\nUnreferenced "+cls.name+"s:\n" )
 cls.instances.each{
  if( it.references.size() < 2 )
   dro.printout( prettyName( it, kb ) )
 }
}

def deleteUnref() {
 def cls = DisplayUtilities.pickCls( null, kb, [ kb.getCls( ":THING" ) ] )
 dro.printout( "\nDelete Unreferenced "+cls.name+"s:\n" )
 delUnrefClass( cls.name )
}

def prettyName( i, kb ) {
 def nam = sv( i, "title", kb )
 if( nam == null )
  nam = sv( i, "label", kb )
 if( nam == null )
  nam = i.name
 return nam
}

def delUnrefClass( nam ) {
  def cnt = 0
  kb.getCls( nam ).instances.each{ 
    if( it.references.size() < 2 )
    {
      kb.deleteInstance( it )
      cnt++
    } 
  }
  dro.printout( cnt+" "+nam+"s deleted" )
}

def deleteScenarios() {
 def ii = DisplayUtilities.pickInstances( null, kb, [ kb.getCls( "Scenario" ) ] )
 dro.printout( "\nDeleting scenarios:\n" )
 ii.each{ 
  def tit = sv( it, "title", kb )
  deleteTasks( svs( it, "initial_tasks", kb ) )
  kb.deleteInstance( it )
  delUnrefClass( "ScenarioScheme" )
  delUnrefClass( "TaskScheme" )
  delUnrefClass( "Context" )
  delUnrefClass( "Pair" )
  delUnrefClass( "Variable" )
  dro.printout( "Scenario "+tit+" deleted" )
 }
}

def deleteTasks( tasks ) {
 tasks.each{
  def tit = sv( it, "title", kb )
  def nt = svs( it, "next_tasks", kb )
  def vt = svs( it, "variants", kb )
  deleteActions( svs( it, "initial_actions", kb ) )
  kb.deleteInstance( it )
  deleteTasks( nt )
  deleteTasks( vt )
  dro.printout( "  Task "+tit+" deleted" )
 }
}

def deleteActions( actions ) {
 actions.each{
  def tit = sv( it, "title", kb )
  def aa = svs( it, "next_actions", kb )
  kb.deleteInstance( it )
  deleteActions( aa )
  dro.printout( "    Action "+tit+" deleted" )
 }
}

def LSPF() {
 JOptionPane.showMessageDialog( null, "Load Second Project first!" )
 return null
}

def copyScenarios( kb2 ) {
 if( kb2 == null )
  return LSPF()
 def ii = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( "Scenario" ) ] )
 dro.printout( "\nCopy scenarios:\n" )
 ii.each{ 
  dro.printout( sv( it, "title", kb2 ) )
  copyInstWithTitOrLab( it, kb, kb2 )
 }
}

def copyInstances( kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( ":THING" ) ] )
 dro.printout( "\nCopy instances:\n" )
 def cnt = 1
 lst.each{
  def nsv = nameSlotVal( it, kb2 )
  copyInstWithTitOrLab( it, kb1, kb2 )
  dro.printout( cnt+". "+nsv[0]+": "+nsv[1] )
  cnt++
 }
}

def nameSlotVal( i, kb2 ){
 def sn = "title"
 def nam = sv( i, sn, kb2 )
 if( nam == null ){
  sn = "label"
  nam = sv( i, sn, kb2 )
 }
 if( nam == null )
  return null
 else
  return [ sn, nam ]
}

def copyInstWithTitOrLab( i, kb1, kb2 ) {
 if( i == null )
  return null
 def nsv = nameSlotVal( i, kb2 )
 if( nsv == null )
  return null
 def tn = i.directType.name
 def e = dro.findForSlotValue( tn, nsv[0], nsv[1] )
 if( e != null ){
  kb1.deleteInstance( e )
  dro.printout( "Deleted instance with "+nsv[0]+": "+nsv[1] )
 }
 def typ = kb1.getCls( tn )
 if( typ == null ) {
  dro.printout( "Class of "+i+" not exists!" )
  return null;
 }
 def c = kb1.createInstance( null, typ )
 ssv( c, nsv[0], nsv[1], kb1 )
 typ.templateSlots.each{
  def sn = it.name
  if( sn != nsv[0] && !sn.startsWith( ":" ) ) {
   if( it.allowsMultipleValues )
    ssvs( 
     c, 
     sn, 
     svs( i, sn, kb2 ).collect{ findOrCreateCopy( it, kb1, kb2 ) }, 
     kb1 
    )
   else
    ssv( c, sn, findOrCreateCopy( sv( i, sn, kb2 ), kb1, kb2 ), kb1 )
  }
 }
 c
}

def findOrCreateCopy( v2, kb1, kb2 ) {
 if( v2 instanceof Cls ) {
   def cc = kb1.getCls( v2.name )
   if( cc == null )
     dro.printout( "Copy class "+v2+" before!" )
   return cc  
 }
 if( v2 instanceof Instance ) {
  def tn = v2.directType.name
  def nsv = nameSlotVal( v2, kb2 )
  if( nsv == null )
   return null
  def cv = dro.findForSlotValue( tn, nsv[0], nsv[1] )
  if( cv == null ) {
   return copyInstWithTitOrLab( v2, kb1, kb2 )
  } else
   return cv
 } else
  return v2
}

def convertScenario( i, kb1, kb2 ) {
}

def filch( s ) {
 def c = new JFileChooser( s )
 def rv = c.showOpenDialog( null )
 if ( rv == javax.swing.JFileChooser.APPROVE_OPTION ) {
  return c.selectedFile.path
 }
 null
}

def getDir( path ) {
 def i = path.lastIndexOf( "/" )
 path.substring( 0, i )
}

def swb = new groovy.swing.SwingBuilder()
def path
def prj2
def kb2
def frame = swb.frame( title: 'Scenario Processing' ) {
 boxLayout(axis:BoxLayout.Y_AXIS)
 panel( border: BorderFactory.createTitledBorder( "Functions" ) ) {
  gridLayout( columns:1, rows: 6 )
  button ( text: 'Load Second Project', actionPerformed: {
   path = definePath( path, prj )   
   prj2 = loadSecondProject( path, prj2 )
   kb2 = prj2.knowledgeBase 
  } )
  button ( text: 'Find Unreferenced', actionPerformed: { findUnref() } )
  button ( text: 'Delete Unreferenced', actionPerformed: { deleteUnref() } )
  button ( text: 'Delete Scenarios', actionPerformed: { deleteScenarios() } )
  button ( text: 'Copy Scenarios', actionPerformed: { copyScenarios( kb2 ) } )
  button ( text: 'Copy TL-Instances', actionPerformed: { copyInstances( kb, kb2 ) } )
 }
}
frame.pack()
frame.show()