import edu.stanford.smi.protege.model.*
import edu.stanford.smi.protege.ui.*
import java.awt.BorderLayout
import javax.swing.*

def sv( i, s, kb ) {
 i.getOwnSlotValue( kb.getSlot( s ) )
}

def svs( i, s, kb ) {
 i.getOwnSlotValues( kb.getSlot( s ) )
}

def ssv( i, s, v, kb ) {
 i.setOwnSlotValue( kb.getSlot( s ), v )
}

def ssvs( i, s, v, kb ) {
 i.setOwnSlotValues( kb.getSlot( s ), v )
}

def definePath( p, prj ) {
 if( p == null )
  p = prj.projectDirectoryFile.path
 filch( p )
}

def loadSecondProject( p, prj2 ) {
 if( p == null )
  return
 def err = new ArrayList()
 if( prj2 != null )
  prj2.dispose()
 prj2 = new Project( p, err )
 dro.printout( "\nloading "+p+" errors "+err.size )
 if( err.size > 0 ){
  err.each{ dro.printout( "error: "+it ) }
  return null
 }
 prj2
}

def LSPF() {
 JOptionPane.showMessageDialog( null, "Load Second Project first!" )
 return null
}

def compareActivities( typ, kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 dro.printout( "\nCompare "+typ+"s by names:\n" )
 def aa1 = kb1.getCls( typ ).instances
 def nn1 = aa1.collect{ it.name }
 def aa2 = kb2.getCls( typ ).instances
 def nn2 = aa2.collect{ it.name }
 def only1 = nn1.findAll{ !nn2.contains( it ) }
 def only2 = nn2.findAll{ !nn1.contains( it ) }
 dro.printout( "Only in this project:\n"+only1 )
 dro.printout( "Only in second project:\n"+only2 )
}

def compareAny( typ, sl, kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 dro.printout( "\nCompare "+typ+"s by "+sl+":\n" )
 def aa1 = kb1.getCls( typ ).instances
 def nn1 = aa1.collect{ sv( it, sl, kb1 ) }
 def aa2 = kb2.getCls( typ ).instances
 def nn2 = aa2.collect{ sv( it, sl, kb2 ) }
 def only1 = nn1.findAll{ !nn2.contains( it ) }
 def only2 = nn2.findAll{ !nn1.contains( it ) }
 dro.printout( "Only in this project:\n"+only1 )
 dro.printout( "Only in second project:\n"+only2 )
}

def compareBySlot( sl, kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def cls = DisplayUtilities.pickCls( null, kb2, [ kb2.getCls( ":THING" ) ] ) 
 compareAny( cls.name, sl, kb1, kb2 )
}

def copySlot( os, kb1 ) {
 dro.printout( "  copy slot: "+os.name )
 def cs = kb1.createSlot( os.name )
 cs.valueType = os.valueType
 cs.allowsMultipleValues = os.allowsMultipleValues
 cs.maximumCardinality = os.maximumCardinality
 cs.minimumCardinality = os.minimumCardinality
 def acc = os.allowedClses
 if( ! acc.isEmpty() ) 
  cs.allowedClses = listClsesByName( acc, kb1 )
 cs
}
           
def listClsesByName( cc, kb1 ) {
 def nn = cc.collect{ it.name }
 nn.collect{ kb1.getCls( it ) }
}

def copyActivityCls( typ, ac, kb1, kb2 ) {
 def acc = kb1.getCls( typ )
 def cc = kb1.createInstance( ac.name, acc )
 def sc = listClsesByName( ac.directSuperclasses, kb1 )
 sc.each{ cc.addDirectSuperclass( it ) }
 def dts = ac.directTemplateSlots.collect{
  def s = kb1.getSlot( it.name )
  ( s != null ? s : copySlot( it, kb1 ) )
 }
 dts.each{ cc.addDirectTemplateSlot( it ) }
 def ts = acc.templateSlots.each{ 
  if( !it.name.startsWith( ":" ) )
   cc.setOwnSlotValue( it, sv( ac, it.name, kb2 ) ) 
 }
 cc
}

def copyClasses( kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickClses( null, kb2, [ kb2.getCls( ":THING" ) ] )
 dro.printout( "\nCopy classes:\n" )
 lst.each { copyCls( it, kb1, kb2 ) } 
}

def copyCls( c2, kb1, kb2 ) {
 def a = JOptionPane.YES_OPTION
 def c1 = kb1.getCls( c2.name )
 if( c1 != null ) {
  a = JOptionPane.showConfirmDialog( null, "Class "+c2.name+" exists in this project!\nReplace it?" )
  if( a == JOptionPane.YES_OPTION )
   kb1.deleteInstance( c1 )
 } 
 if( a != JOptionPane.YES_OPTION )
  return
 dro.printout( " "+c2.name )
 c1 = kb1.createCls( c2.name, listClsesByName( c2.directSuperclasses, kb1 ) ) 
 def dts = c2.directTemplateSlots.collect {
  def s = kb1.getSlot( it.name )
  ( s != null ? s : copySlot( it, kb1 ) )
 }
 dts.each{ c1.addDirectTemplateSlot( it ) }
}

def copyActivities( typ, kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( typ ) ] )
 if( !lst.isEmpty() ) 
  copyClassList( typ, lst, kb1, kb2 )
}

def copyClassList( typ, lst, kb1, kb2 ) {
 dro.printout( "\nCopy "+typ+":\n" )
 lst.each{
  def a = JOptionPane.YES_OPTION
  def ea = kb.getCls( it.name )
  if( ea != null ) {
   a = JOptionPane.showConfirmDialog( null, it.name+" of "+typ+" exists in this project!\nReplace it?" )
   if( a == JOptionPane.YES_OPTION )
    kb1.deleteInstance( ea )
  } 
  if( a == JOptionPane.YES_OPTION ) {
   copyActivityCls( typ, it, kb1, kb2 )
   dro.printout( it.name+" of "+typ+" copied.." )
  }
 }
}

def copyInstances( kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( ":THING" ) ] )
 dro.printout( "\nCopy instances:\n" )
 lst.each{
  copyInstanceShallow( it, kb1, kb2 )
 }
}

def copyPackages( kb1, kb2 ) {
 if( kb2 == null )
  return LSPF()
 def lst = DisplayUtilities.pickInstances( null, kb2, [ kb2.getCls( "Package" ) ] ) 
 lst.each{
  deleteExistingByTitleOrLabel( it, kb1, kb2 )
  copyPackage( it, kb1, kb2 )
 }
}

def copyPackage( p, kb1, kb2 ) {
 def c = kb1.createInstance( null, kb1.getCls( "Package" ) )
 ssv( c, "title", sv( p, "title", kb2 ), kb1 )
 dro.printout( "\nCopy Package: "+sv( c, "title", kb1) )
 ssv( c, "path", sv( p, "path", kb2 ), kb1 )
 ssv( c, "expander", sv( p, "expander", kb2 ), kb1 )
 ssvs( c, "imports", new ArrayList( svs( p, "imports", kb2 ) ), kb1 )
 ssvs( c, "suffix-wslot-tslot", new ArrayList( svs( p, "suffix-wslot-tslot", kb2 ) ), kb1 )
 ssv( c, "dsl", copyInstanceShallow( sv( p, "dsl", kb2 ), kb1, kb2 ), kb1 )
 dro.printout( "\n  Rules: \n" )
 ssvs( c, "rules", svs( p, "rules", kb2 ).collect{ copyInstanceShallow( it, kb1, kb2 ) }, kb1 )
 dro.printout( "\n  Globals: \n" )
 ssvs( c, "globals", svs( p, "globals", kb2 ).collect{ copyInstanceShallow( it, kb1, kb2 ) }, kb1 )
 dro.printout( "\n  Functions: \n" )
 ssvs( c, "functions", svs( p, "functions", kb2 ).collect{ copyInstanceShallow( it, kb1, kb2 ) }, kb1 )
 dro.printout( "\n  For Creation: \n" )
 ssvs( c, "for-creation", svs( p, "for-creation", kb2 ).collect{ copyClsForCreation( it, kb1, kb2 ) }, kb1 )
}

def copyClsForCreation( cls, kb1, kb2 ) {
 if( cls == null )
  return cls
 def suf = ""
 def e = kb1.getCls( cls.name )
 if( e != null ) {
  kb1.deleteCls( e )
  suf = " - replaced old"
 }
 dro.printout( cls.name+suf )
 copyActivityCls( cls.directType.name, cls, kb1, kb2 )
}

def copyInstanceShallow( i, kb1, kb2 ) {
 if( i == null )
  return i
 deleteExistingByTitleOrLabel( i, kb1, kb2 )
 def typ = kb1.getCls( i.directType.name )
 if( typ == null ) {
  dro.printout( "Class of "+i+" not exists!" )
  return null;
 }
 def c = kb1.createInstance( null, typ )
 typ.templateSlots.each{
  def sn = it.name
  if( !sn.startsWith( ":" ) ) {
   if( it.allowsMultipleValues )
    ssvs( c, sn, svs( i, sn, kb2 ).collect{ findValueCopy( it, kb2 ) }, kb1 )
   else
    ssv( c, sn, findValueCopy( sv( i, sn, kb2 ), kb2 ), kb1 )
  }
 }
 def nam = sv( c, "title", kb1 )
 if( nam == null )
  nam = sv( c, "label", kb1 )
 if( nam == null )
  nam = c.name
 dro.printout( nam )
 c
}

def findValueCopy( v2, kb2 ) {
 if( v2 instanceof Instance ) {
  def tn = v2.directType.name
  def sn = "title"
  def nam = sv( v2, sn, kb2 )
  if( nam == null ) {
   sn = "label"
   nam = sv( v2, sn, kb2 )
  }
  if( nam == null ) {
   dro.printout( "Attempt to find copy of "+tn+" without title or label: "+v2 )
   return null
  }
  def cv = dro.findForSlotValue( tn, sn, nam )
  if( cv == null )
   dro.printout( "Copy of "+tn+" with "+sn+"=\""+nam+"\" not found!" )
  return cv
 } else
  return v2
}

def deleteExistingByTitleOrLabel( i, kb1, kb2 ) {
 def tn = i.directType.name
 def nam = sv( i, "title", kb2 )
 def e
 if( nam != null )
  e = dro.findForTitle( tn, nam )
 if( e == null ) {
  nam = sv( i, "label", kb2 )
  if( nam != null )
   e = dro.findForSlotValue( tn, "label", nam )
 }
 if( e != null ) {
  kb1.deleteInstance( e )
  dro.printout( "Deleted instance with title/label: "+nam )
 }
}

def filch( s ) {
    def c = new JFileChooser( s )
    def rv = c.showOpenDialog( null )
    if ( rv == javax.swing.JFileChooser.APPROVE_OPTION ) {
        return c.selectedFile.path
    }
    null
}

def getDir( path ) {
    def i = path.lastIndexOf( "/" )
    path.substring( 0, i )
}

def swb = new groovy.swing.SwingBuilder()
def path
def prj2
def kb2
def frame = swb.frame( title: 'Share Ontology' ) {
 boxLayout(axis:BoxLayout.Y_AXIS)
 panel( border: BorderFactory.createTitledBorder( "Functions" ) ) {
  gridLayout( columns:1, rows: 11 )
  button ( text: 'Load Second Project', actionPerformed: {
   path = definePath( path, prj )   
   prj2 = loadSecondProject( path, prj2 )
   kb2 = prj2.knowledgeBase 
  } )
  button ( text: 'Compare Actions', actionPerformed: { compareActivities( "ActionClass", kb, kb2 ) } )
  button ( text: 'Compare Decisions', actionPerformed: { compareActivities( "DecisionClass", kb, kb2 ) } )
  button ( text: 'Compare Packages', actionPerformed: { compareAny( "Package", "title", kb, kb2 ) } )
  button ( text: 'Compare By Titles', actionPerformed: { compareBySlot( "title", kb, kb2 ) } )
  button ( text: 'Compare By Labels', actionPerformed: { compareBySlot( "label", kb, kb2 ) } )
  button ( text: 'Copy Actions', actionPerformed: { copyActivities( "ActionClass", kb, kb2 ) } )
  button ( text: 'Copy Decisions', actionPerformed: { copyActivities( "DecisionClass", kb, kb2 ) } )
  button ( text: 'Copy Classes', actionPerformed: { copyClasses( kb, kb2 ) } )
  button ( text: 'Copy Packages', actionPerformed: { copyPackages( kb, kb2 ) } )
  button ( text: 'S-Copy Instances', actionPerformed: { copyInstances( kb, kb2 ) } )
 }
}
frame.pack()
frame.show()