(ns file.proc
(:use
  clojure.java.io
  clojure.stacktrace))
(def ^:dynamic *fos* nil)
(defn process-file [path tr-lines func]
(with-open [rdr (reader path)]
   (try
      (def cnt 1)
      (doseq [line (line-seq rdr)]
         (def cline line)
         (func line)
         (def cnt (inc cnt))
         (if (= (mod cnt tr-lines) 0)
             (println (str "Processed " cnt " lines ..." )) ))
      (catch Exception e
         (println (str "LINE " cnt ": "cline))
         (print-cause-trace e)
         (println)))
   (dec cnt)))
(defn process-lines [n path tr-lines func]
(with-open [rdr (reader path)]
   (try
      (def cnt 1)
      (doseq [line (take n (line-seq rdr))]
         (def cline line)
         (func line)
         (def cnt (inc cnt))
         (if (= (mod cnt tr-lines) 0)
             (println (str "Processed " cnt " lines ..." )) ))
      (catch Exception e
         (println (str "LINE " cnt ": "cline))
         (print-cause-trace e)
         (println)))
   (dec cnt)))
(defn filter-file [from to trl func]
(def ^:dynamic *fos* (writer to))
(process-file from trl func)
(.close *fos*))
(defn filter-lines [n from to trl func]
(def ^:dynamic *fos* (writer to))
(process-lines n from trl func)
(.close *fos*))
(defn write-line [line]
(.write *fos* (str line "\n")))
(defn split-on-whitespace-or-tab [line]
(seq (.split line "[\\s\\t]")))
(defn split-on-tab [line]
(seq (.split line "[\\t]")))
